
#include "gis.h"
#include "site.h"
#include "display.h"
#include "raster.h"
#include "options.h"
#include "local_proto.h"
#include "stdlib.h"

int draw_points_diamond(struct Cell_head *window, double min_z, double max_z, double Passo, int col)
{
	double U_X, U_Y, U_Z, Z_rel ;
	int D_X, D_Y, D_Z ;
	int N=0;
        int x;

	while(next_point(window, &U_X, &U_Y, &U_Z, col))
	{
	  //if Z is out of range do not print 
		if ((U_Z>=min_z) && (U_Z<=max_z)){
		  //modify Z value in a value in 0-255 range
	        Z_rel = U_Z - min_z;
                Z_rel = Z_rel / Passo;
	        x=(int)Z_rel;
		R_RGB_color(x,x,x);
                D_X = (int)D_u_to_d_col(U_X) ;
		D_Y = (int)D_u_to_d_row(U_Y) ;
		R_move_abs(D_X     , D_Y+size) ;
		R_cont_abs(D_X+size, D_Y     ) ;
		R_cont_abs(D_X     , D_Y-size) ;
		R_cont_abs(D_X-size, D_Y     ) ;
		R_cont_abs(D_X     , D_Y+size) ;
		N++;
		}
	}
	return (N);
}

int draw_points_diamond_color(struct Cell_head *window, double min_z, double max_z, double Passo, int col)
{
	double U_X, U_Y, U_Z;
	int D_X, D_Y, D_Z ;
	int N=0;
        int x,color;
	div_t result;

	while(next_point(window, &U_X, &U_Y, &U_Z, col))
	{
	  //if Z is out of range do not print 
		if ((U_Z>=min_z) && (U_Z<=max_z)){
		  //modify Z value in a value in 0-255 range
		x=(int)U_Z;
		result = div(x,16);
	        color = result.rem;
		if (color==0) color=8;
                R_standard_color(color);
                D_X = (int)D_u_to_d_col(U_X) ;
		D_Y = (int)D_u_to_d_row(U_Y) ;
		R_move_abs(D_X     , D_Y+size) ;
		R_cont_abs(D_X+size, D_Y     ) ;
		R_cont_abs(D_X     , D_Y-size) ;
		R_cont_abs(D_X-size, D_Y     ) ;
		R_cont_abs(D_X     , D_Y+size) ;
		N++;
		}
	}
	return (N);
}

int draw_points_box(struct Cell_head *window, double min_z, double max_z, double Passo, int col)
{
	double U_X, U_Y, U_Z, Z_rel ;
	int D_X, D_Y, D_Z ;
	int N=0;
        int x;

	while(next_point(window, &U_X, &U_Y, &U_Z, col))
	{
		if ((U_Z>=min_z) && (U_Z<=max_z)){
	        Z_rel = U_Z - min_z;
                Z_rel = Z_rel / Passo;
	        x=(int)Z_rel;
		R_RGB_color(x,x,x);
                D_X = (int)D_u_to_d_col(U_X) ;
		D_Y = (int)D_u_to_d_row(U_Y) ;
		R_move_abs(D_X-size, D_Y-size) ;
		R_cont_abs(D_X-size, D_Y+size) ;
		R_cont_abs(D_X+size, D_Y+size) ;
		R_cont_abs(D_X+size, D_Y-size) ;
		R_cont_abs(D_X-size, D_Y-size) ;
		N++;
		}
	}
	return (N);
}

int draw_points_box_color(struct Cell_head *window, double min_z, double max_z, double Passo, int col)
{
	double U_X, U_Y, U_Z, Z_rel ;
	int D_X, D_Y, D_Z ;
	int N=0;
	int x,color;
	div_t result;
        

	while(next_point(window, &U_X, &U_Y, &U_Z, col))
	{
		if ((U_Z>=min_z) && (U_Z<=max_z)){
	        x=(int)U_Z;
		result = div(x,16);
	        color = result.rem;
		if (color==0) color=8;
                R_standard_color(color);
                D_X = (int)D_u_to_d_col(U_X) ;
		D_Y = (int)D_u_to_d_row(U_Y) ;
		R_move_abs(D_X-size, D_Y-size) ;
		R_cont_abs(D_X-size, D_Y+size) ;
		R_cont_abs(D_X+size, D_Y+size) ;
		R_cont_abs(D_X+size, D_Y-size) ;
		R_cont_abs(D_X-size, D_Y-size) ;
		N++;
		}
	}
	return (N);
}

int draw_points_plus_color( struct Cell_head *window, double min_z, double max_z, double Passo, int col)
{
	double U_X, U_Y, U_Z, Z_rel ;
	int D_X, D_Y, D_Z ;
	int N=0;
	int x,color;
	div_t result;

	while(next_point(window, &U_X, &U_Y, &U_Z, col))
	{
	 if ((U_Z>=min_z) && (U_Z<=max_z)){
	        x=(int)U_Z;
		result = div(x,16);
	        color = result.rem;
		if (color==0) color=8;
                R_standard_color(color);
	        D_X = (int)D_u_to_d_col(U_X) ;
		D_Y = (int)D_u_to_d_row(U_Y) ;
		R_move_abs(D_X-size, D_Y     ) ;
		R_cont_abs(D_X+size, D_Y     ) ;
		R_move_abs(D_X     , D_Y-size) ;
		R_cont_abs(D_X     , D_Y+size) ;
		N++;
	 }
	}
	return (N);
}

int draw_points_plus( struct Cell_head *window, double min_z, double max_z, double Passo, int col)
{
	double U_X, U_Y, U_Z, Z_rel ;
	int D_X, D_Y, D_Z ;
	int N=0;
        int x;

	while(next_point(window, &U_X, &U_Y, &U_Z, col))
	{
	 if ((U_Z>=min_z) && (U_Z<=max_z)){
	        Z_rel = U_Z - min_z;
                Z_rel = Z_rel / Passo;
	        x=(int)Z_rel;
		R_RGB_color(x,x,x);
	        D_X = (int)D_u_to_d_col(U_X) ;
		D_Y = (int)D_u_to_d_row(U_Y) ;
		R_move_abs(D_X-size, D_Y     ) ;
		R_cont_abs(D_X+size, D_Y     ) ;
		R_move_abs(D_X     , D_Y-size) ;
		R_cont_abs(D_X     , D_Y+size) ;
		N++;
	 }
	}
	return (N);
}

int draw_points_x( struct Cell_head *window, double min_z, double max_z, double Passo, int col)
{
	double U_X, U_Y, U_Z, Z_rel ;
	int D_X, D_Y, D_Z ;
	int N=0;
        int x;

	while(next_point(window, &U_X, &U_Y, &U_Z, col))
	{
	  if ((U_Z>=min_z) && (U_Z<=max_z)){
	        Z_rel = U_Z - min_z;
                Z_rel = Z_rel / Passo;
	        x=(int)Z_rel;
                R_RGB_color(x,x,x);
		D_X = (int)D_u_to_d_col(U_X) ;
		D_Y = (int)D_u_to_d_row(U_Y) ;
		R_move_abs(D_X-size, D_Y-size) ;
		R_cont_abs(D_X+size, D_Y+size) ;
		R_move_abs(D_X+size, D_Y-size) ;
		R_cont_abs(D_X-size, D_Y+size) ;
		N++;
	  }
	}
	return (N);
}

int draw_points_x_color( struct Cell_head *window, double min_z, double max_z, double Passo, int col)
{
	double U_X, U_Y, U_Z, Z_rel ;
	int D_X, D_Y, D_Z ;
	int N=0;
        int x,color;
	div_t result;

	while(next_point(window, &U_X, &U_Y, &U_Z, col))
	{
	  if ((U_Z>=min_z) && (U_Z<=max_z)){
	        x=(int)U_Z;
		result = div(x,16);
	        color = result.rem;
		if (color==0) color=8;
                R_standard_color(color);
		D_X = (int)D_u_to_d_col(U_X) ;
		D_Y = (int)D_u_to_d_row(U_Y) ;
		R_move_abs(D_X-size, D_Y-size) ;
		R_cont_abs(D_X+size, D_Y+size) ;
		R_move_abs(D_X+size, D_Y-size) ;
		R_cont_abs(D_X-size, D_Y+size) ;
		N++;
	  }
	}
	return (N);
}

int next_point (
	struct Cell_head *window,
	double *U_X,
	double *U_Y,
	double *U_Z, 
	int col)
{
        static Site *s;
	static int first=1;
	static int ndim, ndec;
	static RASTER_MAP_TYPE rtype;

	if(first){
	int nstr;
	    first=0;
	    rtype = -1;
	    G_site_describe (infile, &ndim, &rtype, &nstr, &ndec);
	    s=G_site_new_struct(rtype,ndim,nstr,ndec); 
	}

	do
        {
                if (G_site_get (infile, s) != 0)
                        return 0;
        }
        while(!G_site_in_region(s,window));

        *U_X=s->east;
        *U_Y=s->north;
        *U_Z=s->dbl_att[col];

	return 1;
}
